typedef struct Screen TScreen;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int           ObjectsCount;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           LinesCount;
  TLine                  * const code *Lines;
};

extern   TScreen                Screen1;
extern   TBox                   Box3;
extern   TBox                   Box2;
extern   TBox                   Box1;
extern   TLabel                 Label1;
extern   TLine                  Line1;
extern   TLabel                 Label9;
extern   TLabel                 Label10;
extern   TBox                   Box4;
extern   TLabel                 Label5;
extern   TBox                   Box5;
extern   TLabel                 Label11;
extern   TBox                   Box6;
extern   TLabel                 Label15;
extern   TBox                   Box7;
extern   TBox                   Box8;
extern   TLabel                 Label6;
extern   TLabel                 Label4;
extern   TLabel                 Label2;
extern   TLabel                 Label3;
extern   TLabel                 accelX;
extern   TLabel                 accelY;
extern   TLabel                 accelZ;
extern   TLabel                 Label7;
extern   TLabel                 Label8;
extern   TLabel                 Label12;
extern   TLabel                 gyroX;
extern   TLabel                 gyroY;
extern   TLabel                 gyroZ;
extern   TLabel                 lblTemp;
extern   TLabel                 Label13;
extern   TLabel                 Label14;
extern   TLabel                 Label16;
extern   TLabel                 magX;
extern   TLabel                 magY;
extern   TLabel                 magZ;
extern   TLabel                 Label17;
extern   TLabel                 Label18;
extern   TLabel                 Label19;
extern   TLabel                 * const code Screen1_Labels[29];
extern   TBox                   * const code Screen1_Boxes[8];
extern   TLine                  * const code Screen1_Lines[1];


/////////////////////////
// Events Code Declarations
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Box3_Caption[];
extern char Box2_Caption[];
extern char Box1_Caption[];
extern char Label1_Caption[];
extern char Line1_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Box4_Caption[];
extern char Label5_Caption[];
extern char Box5_Caption[];
extern char Label11_Caption[];
extern char Box6_Caption[];
extern char Label15_Caption[];
extern char Box7_Caption[];
extern char Box8_Caption[];
extern char Label6_Caption[];
extern char Label4_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char accelX_Caption[];
extern char accelY_Caption[];
extern char accelZ_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label12_Caption[];
extern char gyroX_Caption[];
extern char gyroY_Caption[];
extern char gyroZ_Caption[];
extern char lblTemp_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];
extern char Label16_Caption[];
extern char magX_Caption[];
extern char magY_Caption[];
extern char magZ_Caption[];
extern char Label17_Caption[];
extern char Label18_Caption[];
extern char Label19_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
